unit Math;
{$mode objfpc}
interface

type 
TMath = class
  private
    farray:array[word] of int64;
    flast: word;
    class function getF(index: word): int64;
  public
    constructor create();
    property F[index: word]: int64 read getF;
end;


var MathObject:TMath;
implementation


constructor TMath.Create();
 begin
    inherited create;
    farray[0]:=1;
    farray[1]:=1;
    flast:=1;
end;

// первая версия - без оптимизации
class function TMath.getF(index: word): int64;
 begin
  if index in [0,1] then
    result:=1
  else 
    result:=index*getf(index-1)
 end;

{
// вторая версия - с оптимизацией
class function TMath.getF(index: word): int64;
 begin
  if index <= flast then
    result:=farray[index]
  else begin
    // см. лекцию
  end;
 end;
}

initialization
 MathObject:=TMath.Create();
finalization
 MathObject.Destroy();
end.