{$mode objfpc}
unit datastore;
interface

type
TDataStore = Class
  Private 
   data: file;
  Protected 
   Procedure storedata(Var dt; count:integer);
   Procedure loaddata(Var dt; count: integer);
  Public 
   constructor create(fn:String);
   destructor destroy(); override;
End;

TIntegerStore = Class(TDataStore)
  Public 
   Procedure put(x: integer);
   Function get: integer;
End;

implementation
 uses sysutils;

//------------ TDATASTORE ---------------

constructor TDataStore.create(fn:String);
begin
 inherited create();
 assignfile(data, fn);
 If fileexists(fn) Then reset(data, 1)
 Else rewrite(data, 1);
end;

destructor TDataStore.destroy;
begin
 closefile(data);
 inherited destroy;
end;

Procedure TDataStore.storedata(Var dt; count:integer);
begin
 seek(data, 0);
 blockwrite(data, dt, 0);
end;

Procedure TDataStore.loaddata(Var dt; count: integer);
begin
 // TODO
end;

//------------ TIntegerStore ---------------
Procedure TIntegerStore.put(x: integer);
 begin
 // TODO
 end;
    
Function TIntegerStore.get: integer;
 begin
 // TODO
 end;
end.